C
C---- AIRSET code global INCLUDE file
C
      PARAMETER (IX=1000, LX=15, NKEYX=8)
C
      LOGICAL LAIR,LPLOT,LGAMU,LGLIN,LCPSHO,
     &        LNODE,LSPLIN,LGSLOP,LIMAGE,LNUMB
      LOGICAL LCLOCK,LHOME
      LOGICAL LKEY
C
      REAL MINF
C
      CHARACTER*32 NAME
      CHARACTER*80 FNAME, OFNAME, MGPARS
C
      CHARACTER*8  KEYNAM, KEYPRT
      CHARACTER*80 KEYDEF
C
      COMMON/ACOMR/ VERSION, PI,DTOR,MINF,CPSTAR,YGROUND,
     &              SIZE,CH,AR,XWIND,YWIND,SCRNFR,
     &              SF,XOFF,YOFF,
     &              XMIN, XMAX, YMIN, YMAX, DXY,
     &              PSF,POFF,
     &              CPMIN, CPMAX, CPDEL,
     &              XOFAIR,YOFAIR,FACAIR,
     &              ALFA,CL,CD,CM,CLEL(LX),CDEL(LX),CMEL(LX),
     &              FNBLD1,CVPAR1,CTERAT1, CVPAR(LX),CTERAT(LX),
     &              X(IX,LX),  Y(IX,LX),  XB(IX,LX), YB(IX,LX),
     &              XP(IX,LX), YP(IX,LX), S(IX,LX),  SLE(LX),
     &              CHRD(LX), ANG(LX),
     &              XLE(LX), YLE(LX), XTE(LX), YTE(LX),
     &              XREF(LX), YREF(LX),
     &              ANGSUM(LX),DXSUM(LX),DYSUM(LX),
     &              XFTOT(LX),YFTOT(LX),
     &              XCENT(LX),YCENT(LX),
     &              XCMOM,YCMOM
      COMMON/ACOMC/ FNAME,OFNAME,NAME,NNAME,MGPARS,
     &              KEYNAM(NKEYX),KEYPRT(NKEYX),KEYDEF(NKEYX)
      COMMON/ACOMI/ IDEV,IDEVRP,IPSLU,
     &              IINPUT(40), NPAN1, NPAN(LX),
     &              NBL, NLINK(LX), NPBL(LX)
      COMMON/ACOML/ LAIR,LPLOT,LGAMU,LGLIN,LCPSHO,
     &              LNODE,LSPLIN,LGSLOP,LIMAGE,LNUMB,
     &              LCLOCK(LX), LHOME(LX),
     &              LKEY(NKEYX)
      COMMON/AWORK/ W1(IX),W2(IX),W3(IX),W4(IX),
     &              W5(IX),W6(IX),W7(IX),W8(IX),AINPUT(40)
C
C
C   VERSION    AIRSET version number
C
C   PI         3.1415926
C   DTOR       3.1415926/180.0
C   MINF       freestream Mach for Karman-Tsien corrections
C   CPSTAR     sonic Cp
C   YGROUND    y location of ground plane (used only if LIMAGE=t)
C
C
C   SIZE       absolute plot size
C   CH         character height   (relative to plot width = 1)
C   AR         plot aspect ratio
C
C   XWIND      window dimensions
C   YWIND    
C   SCRNFRC    screen fraction taken up by plot window at startup
C   
C   SF         scale factor for blowups
C   XOFF       x offset for blowups
C   YOFF       y offset for blowups
C   
C   XMIN       airfoil limits for plot scaling
C   XMAX
C   YMIN
C   YMAX
C
C   DXY        geometry grid plot increment
C
C   PSF        Cp scale factor
C   POFF       Cp offset
C
C   CPMIN      Cp axis annotation limits
C   CPMAX
C   CPDEL      Cp axis annotation increment
C   PFAC       Cp scale for  Cp vs x  plot
C   
C   XOFAIR     airfoil offsets for  Cp vs x  plot
C   YOFAIR
C   FACAIR     airfoil scale factor for  Cp vs x  plot
C
C   ALFA       current angle of attack
C   CL         current total forces
C   CD
C   CM
C   CLEL(.)    current element forces
C   CDEL(.)
C   CMEL(.)
C
C   FNBLD1     exponent for setting NPAN
C   CVPAR1     curvature-weighting factor for panel density
C   CTERAT1    TE/LE panel density ratio
C   CVPAR(n)   actual CVPAR for each element
C   CTERAT(n)  actual CTERAT for each element
C
C   X(i,n)     x coordinates
C   Y(i,n)     y coordinates
C   XB(i,n)    x coordinates of buffer airfoil
C   YB(i,n)    y coordinates of buffer airfoil
C   
C   XP(i,n)    dX/dS  spline derivatives
C   YP(i,n)    dY/dS  spline derivatives
C   S(i,n)     arc length (spline parameter)
C   SLE(n)     leading edge value of S
C   
C   CHRD(n)    element chord
C   ANG(n)     angle of element chord line
C   
C   XLE(n)     element leading and traling edge coordinates
C   YLE(n)
C   XTE(n)
C   YTE(n)
C   
C   XREF(n)    element reference point
C   YREF(n)
C   
C   ANGSUM(n)  accumulated angle changes since home position was set
C   DXSUM(n)   accumulated x-position changes
C   DYSUM(n)   accumulated y-position changes
C   XFTOT(n)   accumulated x-scalings
C   YFTOT(n)   accumulated y-scalings
C   
C   XCENT(n)   element centroid
C   YCENT(n)
C
C   XCMOM      location about which CM is defined
C   YCMOM
C
C   FNAME      generic filename
C   OFNAME     filename of last overlay airfoil
C   NAME       case name
C   NNAME      number of non-blank characters in NAME
C   MGPARS     MSES grid parameter string (2nd line of blade.xxx)
C
C   KEYNAM(.)  user-key name                     (e.g. ^[[A       )
C   KEYPRT(.)  user-key printname                (     up-arrow   )
C   KEYDEF(.)  user-key binding for EDIT menu    (     T 0.0 0.01 )
C
C   IDEV       Plot-type specifier
C   IDEVRP     Replot-type specifier (for PostScript)
C   IPSLU      PostScript output file specifier
C
C   IINPUT(.)  generic integer input array
C
C   NPAN1      number of panels on maximum-chord element
C   NPAN(n)    actual number of nodes on element (n)
C
C   NBL        number of elements
C   NLINK(n)   number of elements linked to element n
C   NPBL(n)    number of node points in element n
C
C   LAIR      .TRUE. if airfoil is currently loaded
C   LPLOT     .TRUE. if plot is currently open
C   LGAMU     .TRUE. if unit-vorticity distributions exist
C   LGLIN     .TRUE. if element-displacement sensitivities exist
C   LCPSHO    .TRUE. if Cp response to element displacements is plotted
C   
C   LNODE     .TRUE. if nodes are to be plotted
C   LSPLIN    .TRUE. if plotting is to be via spline interpolation
C   LGSLOP    .TRUE. if slope matching is to be performed
C   LIMAGE    .TRUE. if ground-plane image is present
C
C   LCLOCK(n) .TRUE. if input element was clockwise-ordered
C   LHOME(n)  .TRUE. if element m is in its home position
C
C   W1..W8(i)  work arrays
C
C   AINPUT(.)  generic real input array
C
