
      SUBROUTINE SNWRIT(IP)
      INCLUDE 'STATE.INC'
      INCLUDE 'MSES.INC'
      INCLUDE 'SENS.INC'
      DIMENSION ILE(NBX), ITE(NBX)
      DIMENSION SBLEP(NBX)
      CHARACTER*80 ARGP1, FNAME
      CHARACTER*32 CODE
C
C---- overlay temporary storage to save space
ccc      COMMON/WORK/ GNT(IX,ISX,NMODX)
      DIMENSION GNT(IX,ISX,NMODX)
C
      CHARACTER*2 PNUM(99)
      CHARACTER*10 DIGITS
      DATA DIGITS / '0123456789' /
C
C---- fill array for constructing filename suffix
      DO 2 KP=1, 99
        K2 =          KP/10   + 1
        K1 = KP - 10*(KP/10)  + 1
        PNUM(KP) = DIGITS(K2:K2) // DIGITS(K1:K1)
 2    CONTINUE
C
C---- defined re-ordered mode shape array for passing to IOLIB
      DO 3 NN=1, NMODN
        K = KMODN(NN)
        DO 32 IS=1, 2*NBL
          N = (IS+1)/2
          DO 324 IG=1, NBLD(N)
            GNT(IG,IS,K) = GN(K,IG,IS)
 324      CONTINUE
 32     CONTINUE
 3    CONTINUE
C
C
      CDV = DRAGV / QU
      CDW = DRAGW / QU
      CDF = DRAGF / QU
C
      CL  = LIFT  / QU
      CM  = MOMN  / QU
C
C---- set current freestream Reynolds number
      REINF = REYN * RHOINF*QINF/MUINF
C
C---- indices indicating if Minf(mass), REinf(mass,REo) are active global 
C-    variables -- i.e. dCL/dMinf, dCL/dREinf...  were calculated in GLOSEN
      LMINF = LMASS
      LRINF = LREYN
C
C---- REinf(mass,REo) is active only if both mass flow 
C-    and stagnation Reynolds number are active
      IF(LMASS.EQ.0 .OR. LREYN.EQ.0) LRINF = 0
C
C
      DO 5 N=1, NBL
        ILE(N) = NINL(N)
        ITE(N) = NINL(N)+NBLD(N)-1
        SBLEP(N) = SBLEGN(N) - SBLE(N)
 5    CONTINUE
C
C
C---- get run output argument xxx
      CALL GETARG(1,ARGP1)
C
      IF(IP.EQ.0) THEN
       FNAME = 'sensx.' // ARGP1
      ELSE
       IBLANK = INDEX(ARGP1,' ')
       FNAME = 'sensx.' // ARGP1(1:IBLANK-1) // '_' // PNUM(IP)
      ENDIF
      LU = 8
      IERR = IOOPER(LU,FNAME,'UNKNOWN')
      IF(IERR.LT.0) GO TO 99
C
      CODE = 'MSES'
      CALL IOWRIT(LU,'a!',32,LEN(CODE),CODE)
      CALL IOWRIT(LU,'a!',32,LEN(NAME),NAME)
      CALL IOWRIT(LU,'3i!',LALFA,LMINF,LRINF)
      CALL IOWRIT(LU,'2l!',LDEPMA,LDEPRE)
      CALL IOWRIT(LU,'3f!',ALFA,MINF,REINF)
      CALL IOWRIT(LU,'6f!',DNRMS,DRRMS,DVRMS,DNMAX,DRMAX,DVMAX)
      CALL IOWRIT(LU,'4i!',II,NBL,NMODN,NPOSN)
C
      CALL IOWRIT(LU,'2i1!',NBL,NBX,ILEB,ITEB)
      CALL IOWRIT(LU,'5f1!',NBL,NBX,XBNOSE,YBNOSE,XBTAIL,YBTAIL,SBLEP)
C
      CALL IOWRIT(LU,'23f!',
     &           CL     , CM     , CDW     , CDV     , CDF     ,
     &  AL_ALFA, CL_ALFA, CM_ALFA, CDW_ALFA, CDV_ALFA, CDF_ALFA,
     &  AL_MINF, CL_MINF, CM_MINF, CDW_MINF, CDV_MINF, CDF_MINF,
     &  AL_RINF, CL_RINF, CM_RINF, CDW_RINF, CDV_RINF, CDF_RINF )
C
      DO 105 IS=1, 2*NBL
        N = (IS+1)/2
        I = ILE(N)
        ITOT = II-ILE(N)
        IDIM = IX-ILE(N)
        CALL IOWRIT(LU,'10f1!',ITOT,IDIM,
     &            XBI(I,IS),YBI(I,IS),
     &            CP(I,IS)     ,HK(I,IS)     ,
     &            CP_ALFA(I,IS),HK_ALFA(I,IS),
     &            CP_MINF(I,IS),HK_MINF(I,IS),
     &            CP_RINF(I,IS),HK_RINF(I,IS) )
c
c     &            MD(I,IS)     ,ST(I,IS)     ,
c     &            MD_ALFA(I,IS),CT_ALFA(I,IS),
c     &            MD_MINF(I,IS),CT_MINF(I,IS),
c     &            MD_RINF(I,IS),CT_RINF(I,IS),
c
 105  CONTINUE
C
      DO 20 NN=1, NMODN
        K = KMODN(NN)
        CALL IOWRIT(LU,'7f!', MODN(K), 
     &            AL_MOD(K),  CL_MOD(K),  CM_MOD(K), 
     &           CDW_MOD(K), CDV_MOD(K), CDF_MOD(K) )
        DO 205 IS=1, 2*NBL
          N = (IS+1)/2
          IG = 1
          IGTOT = ITE(N) - ILE(N) + 1
          IGDIM = IX     - ILE(N) + 1
          CALL IOWRIT(LU,'f1!',IGTOT,IGDIM,GNT(IG,IS,K))
C
          I = ILE(N)
          ITOT = II-ILE(N)
          IDIM = IX-ILE(N)
          CALL IOWRIT(LU,'4f1!',ITOT,IDIM,
     &      XBI_MOD(I,IS,K),YBI_MOD(I,IS,K),
     &       CP_MOD(I,IS,K), HK_MOD(I,IS,K) )
c
c     &       MD_MOD(I,IS,K), AF_MOD(I,IS,K),
c
 205    CONTINUE
 20   CONTINUE
C
      DO 30 NN=1, NPOSN
        K = KPOSN(NN)
        CALL IOWRIT(LU,'i!', NPOSEL(K))
        CALL IOWRIT(LU, 'i1!',NPOSEL(K),NBX,NBPOS(1,K))
        CALL IOWRIT(LU,'3f1!',NPOSEL(K),NBX,
     &                        XBPOS(1,K),YBPOS(1,K),ABPOS(1,K) )
        CALL IOWRIT(LU,'7f!', POSN(K), 
     &            AL_POS(K),  CL_POS(K),  CM_POS(K), 
     &           CDW_POS(K), CDV_POS(K), CDF_POS(K) )
        DO 305 IS=1, 2*NBL
          N = (IS+1)/2
          I = ILE(N)
          ITOT = II-ILE(N)
          IDIM = IX-ILE(N)
          CALL IOWRIT(LU,'4f1!',ITOT,IDIM,
     &      XBI_POS(I,IS,K),YBI_POS(I,IS,K),
     &       CP_POS(I,IS,K), HK_POS(I,IS,K) )
c
c     &       MD_POS(I,IS,K), AF_POS(I,IS,K),
c
 305    CONTINUE
 30   CONTINUE
C
      CALL IOCLOS(LU)
 99   RETURN
      END ! SNWRIT

